/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.jpa;

import com.supinfo.spitfireboard.dao.CategoryDao;
import com.supinfo.spitfireboard.entities.Category;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author Fabien LOISON
 */
@Stateless
public class JpaCategoryDao implements CategoryDao {
    @PersistenceContext
    private EntityManager em;

    @Override
    public List<Category> getAll() {
        CriteriaBuilder builder = em.getCriteriaBuilder();
        CriteriaQuery<Category> query = builder.createQuery(Category.class);
        query.from(Category.class);
        return em.createQuery(query).getResultList();
    }
    
    
    @Override
    public Category getById(Long id) {
        CriteriaBuilder builder = em.getCriteriaBuilder();
        CriteriaQuery<Category> query = builder.createQuery(Category.class);
        Root<Category> category = query.from(Category.class);
        query.where(builder.equal(category.get("id"), id));
        return em.createQuery(query).getSingleResult();
    }
    
    @Override
    public Long persistCategory(Category category) {
        em.persist(category);
        em.flush();
        return category.getId();
    }
    
    @Override
    public void delete(Long id) {
        Category category = this.getById(id);
        em.remove(category);
    }
}
