/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.servlets;

import com.supinfo.spitfireboard.entities.User;
import com.supinfo.spitfireboard.helpers.Password;
import com.supinfo.spitfireboard.services.UserService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author Fabien LOISON
 */
@ManagedBean
@RequestScoped
public class LoginController {
    
    @EJB
    private UserService userService;

    /**
     * Creates a new instance of LoginRegister
     */
    public LoginController() {
    }
    
    private String getValue(String fieldName) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return (String) facesContext.getExternalContext().getRequestParameterMap().get(fieldName);
    }
    
    public List<String> doLogin() {
        List<String> errors = new ArrayList<String>();
        User user = userService.authenticate(this.getValue("username"), this.getValue("password"));
        // Right username and password
        if (user instanceof User) {
            FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("user", user);
            ExternalContext context = FacesContext.getCurrentInstance().getExternalContext(); 
            try {
                context.redirect("index.xhtml");
            } catch (IOException ex) {
                Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        else {
            errors.add("Wrong username or password.");
        }
        return errors;
    }
    
    public void doLogout() {
        FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("user", null);
    }
    
    public User getLoggedUser() {
        return (User) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("user");
    }
    
}
